<?php if(!defined('IS_CMS')) die();

/***************************************************************
* 
*	AdvEmail - Plugin für Mozilo-CMS 2.0
*	erzeugt spiderbotsichere Emailadressen 
*	
*	Javascript muss aktiviert sein.
*
***************************************************************/
class AdvEmail extends Plugin {


    /***************************************************************
    * 
    * Gibt den HTML-Code zurück, mit dem die Plugin-Variable ersetzt 
    * wird. Der String-Parameter $value ist Pflicht, kann aber leer 
    * sein.
    * 
    ***************************************************************/
    function getContent($value) {
            
        $values = explode(",", $value);
		
		
		//Wenn class nicht leer ist, den Wert an $mailclass weitergeben
		if($this->settings->get("class") != "")
			$mailclass = 'class=\"'.$this->settings->get("class").'\" ';		
		
		return  '<script type="text/javascript">'
				.'var name = "'.$values[0].'";'
				.'var url = "'.$values[1].'";'
				.'var klasse = "'.$mailclass.'";'
				.'document.write(\'<a \' + klasse + \'href="mailto:\' + name + \'@\' + url + \'">\' + name + \'@\' + url + \'<\/a>\');'
				//]]>
				.'</script>';
		
    } // function getContent
    
    
    
    /***************************************************************
    * 
    * Gibt die Konfigurationsoptionen als Array zurück.
    * Ist keine Konfiguration nötig, ist dieses Array leer.
    * 
    ***************************************************************/
    function getConfig() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
   
        // Rückgabe-Array initialisieren
        // Das muß auf jeden Fall geschehen!
        $config = array();
		
		$config['class']  = array(
            "type" => "text",                           // Pflicht:  Eingabetyp
            "description" => "Wert für die Class Eigenschaft:",     // Pflicht:  Beschreibung
            "maxlength" => "100",                       // optional: maximale Länge
            "size" => "30",                             // optional: dargestellte Zeichen
        );
		
		return $config;
		                    
        // Jetzt wird das Optionen-Array in der aktuell verwendeten Sprache zurückgegeben. 
        if(isset($config[$language])) {
            return $config[$language];
        }
        // Stellt das Plugin diese Sprache nicht zur Verfügung, werden die englischen Optionen zurückgegeben.
        else {
            return $config['enEN'];
        }
    } // function getConfig    
    
    
    /***************************************************************
    * 
    * Gibt die Plugin-Infos als Array zurück - in dieser 
    * Reihenfolge:
    *   - Name und Version des Plugins
    *   - für moziloCMS-Version
    *   - Kurzbeschreibung
    *   - Name des Autors
    *   - Download-URL
    *   - Platzhalter für die Selectbox
    * 
    ***************************************************************/
    function getInfo() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
        # nur eine Sprache ---------------------------------
        $info = array(
            // Plugin-Name + Version
            "<b>AdvEmail</b> beta 1.0",
            // moziloCMS-Version
            "2.0",
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            "Erzeugt Emailadressen die vor Spiderbots sicher sind. <br />
			<br />
			Beispiel: {AdvEmail|max.mustermann,mozilo.de}",
            // Name des Autors
            "m4ddy",
            // Download-URL
            "http://www.mozilo.de/forum/index.php?action=media",
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            array(
                '{AdvEmail|}' => 'Kurzbeschreibung'
            )
        );
        // Rückgabe der Infos.
        // Auch hier könnte man die Inhalte natürlich von der aktuell im Admin eingestellten 
        // Sprache abhängig machen - siehe getConfig().
        return $info;
        
    } // function getInfo

} // class AdvEmailPlugin

?>