<?php

if(!defined('IS_CMS')) die();
/***************************************************************
*
* MR_SIDEBAR-Plugin fr moziloCMS.
*
*
* Jedes moziloCMS-Plugin mu...
* - als Verzeichnis [PLUGINNAME] unterhalb von "plugins" liegen.
* - im Pluginverzeichnis eine plugin.conf mit den Plugin-
*   Einstellungen enthalten (diese kann auch leer sein).
* - eine index.php enthalten, in der eine Klasse "[PLUGINNAME]"
*   definiert ist.
*
* Die Plugin-Klasse mu...
* - von der Klasse "Plugin" erben ("class [PLUGINNAME] extends Plugin")
* - folgende Funktionen enthalten:
*   getContent($value)
*       -> gibt die HTML-Ersetzung der Plugin-Variable zurck
*   getConfig()
*       -> gibt die Konfigurationsoptionen als Array zurck
*   getInfo()
*       -> gibt die Plugin-Infos als Array zurck
*
***************************************************************/
class FLEXSIDEBAR extends Plugin {

    /***************************************************************
    *
    * Gibt den HTML-Code zurck, mit dem die Plugin-Variable ersetzt
    * wird. Der String-Parameter $value ist Pflicht, kann aber leer
    * sein.
    *
    ***************************************************************/

		function getContent($value) {

        global $CatPage;
		    global $CAT_REQUEST;
        global $PAGE_REQUEST;
        global $USE_CMS_SYNTAX;
    	  global $EXT_HIDDEN;

		    $content = "";
		    $cat = $CatPage->get_AsKeyName(CAT_REQUEST);                                    // Ermittlung der aktuellen Kategorie (ohne alles)
		    $search = $CatPage->get_AsKeyName(PAGE_REQUEST);                                // Ermittlung der aktuellen Inhaltsseite (ohne alles)
        foreach($CatPage->get_PageArray($cat,array(EXT_HIDDEN)) as $page) {                 // Durcharbeiten eines Arrays aller versteckten Seiten der aktuellen Kategorie
        	  if($value.$search == $page) {                                                 // Sollte eine dabei sein, die mit dem Prfix der aktuellen der aktuellen Inhaltsseite entspricht...
        	  	  $content = $CatPage->get_PageContent($cat,$page,$USE_CMS_SYNTAX,true);    // ...einlesen des Seiten-Inhaltes...
        	  	  return $content;                                                          // ...Rckgabe bzw. Ausgabe/Anzeige des Inhaltes
        	  }
        }
	    	return $content;                                                                // Rckgabe ohne Inhalt
		} // function getContent



    /***************************************************************
    *
    * Gibt die Konfigurationsoptionen als Array zurck.
    * Ist keine Konfiguration ntig, ist dieses Array leer.
    *
    ***************************************************************/
    function getConfig() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");

        /***************************************************************
        *
        * Details (Beispiele folgen weiter unten):
        *
        * Die Funktion liefert ein Array zurck. Dieses enthlt die
        * Eingabefelder, mit denen der User im moziloAdmin Einstellungen
        * am Plugin vornehmen kann.
        * Der "type"-Parameter der Eingabefelder bestimmt, um welche Art
        * Eingabefeld es sich handelt und ist Pflicht. Folgende Werte
        * stehen zur Verfgung:
        *   text            Textfeld (beliebiger Text)
        *   textarea        mehrzeilige Texteingabe
        *   password        Passwortfeld (Anzeige des Inhalts als ***)
        *   checkbox        Checkbox (ja/nein)
        *   radio           Radio-Buttons (entweder/oder)
        *   select          Auswahlliste
        *
        * Die Werte der Eingabefelder werden in die plugin.conf des
        * Plugins geschrieben - der Name des Eingabefelds ist dabei der
        * Schlssel in der plugin.conf (siehe Beispiele).
        *
        ***************************************************************/


        // Rckgabe-Array initialisieren
        // Das mu auf jeden Fall geschehen!
        $config = array();

        // Nicht vergessen: Das gesamte Array zurckgeben
        return $config;

        // Aber halt, alle Optionen wren dann ja in Deutsch - auch fr User, die eine andere
        // Sprache im Admin eingestellt haben!

        // Man kann die Optionen auch in verschiedenen Sprachen beschreiben;
        // angezeigt wird dann die, die im Admin eingestellt ist (z.B. deDE oder enEN).

        // Dafr mu jede Beschreibung natrlich fr verschiedene Sprachen verfgbar sein;
        // hier das Beispiel von zwei Optionen jeweils in Deutsch und Englisch:

        $config['deDE']['janeinoption'] = array(
            "type" => "checkbox",
            "description" => "Ja oder nein?"
        );
        $config['deDE']['texteingabe']  = array(
            "type" => "text",
            "description" => "Bitte Wert eingeben",
            "maxlength" => "100",
            "size" => "30",
            "regex" => "/^[a-z]{3}$/",
            "regex_error" => "Die Eingabe muss genau 3 kleine Buchstaben enthalten."
        );

        $config['enEN']['janeinoption'] = array(
            "type" => "checkbox",
            "description" => "Yes or no?"
        );
        $config['enEN']['texteingabe']  = array(
            "type" => "text",
            "description" => "Please enter a value",
            "maxlength" => "100",
            "size" => "30",
            "regex" => "/^[a-z]{3}$/",
            "regex_error" => "Your input has to consist of exactly three small letters."
        );

        // Jetzt wird das Optionen-Array in der aktuell verwendeten Sprache zurckgegeben.
        if(isset($config[$language])) {
            return $config[$language];
        }
        // Stellt das Plugin diese Sprache nicht zur Verfgung, werden die englischen Optionen zurckgegeben.
        else {
            return $config['enEN'];
        }
    } // function getConfig


    /***************************************************************
    *
    * Gibt die Plugin-Infos als Array zurck - in dieser
    * Reihenfolge:
    *   - Name und Version des Plugins
    *   - fr moziloCMS-Version
    *   - Kurzbeschreibung
    *   - Name des Autors
    *   - Download-URL
    *   - Platzhalter fr die Selectbox
    *
    ***************************************************************/
    function getInfo() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
        # nur eine Sprache ---------------------------------
        $info = array(
            // Plugin-Name + Version
            "<b>Flexibles Sidebar-Plugin</b> 0.2",
            // moziloCMS-Version
            "2.0",
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            "Sidebar-Plugin, mit dem man zu jeder Inhaltsseite eine oder mehrere eigene Sidebar erzeugen kann.<br />
        		Verwendung: {FLEXSIDEBAR|sb1_}<br />
        		Das Praefix (hier: sb1_) ist vollkommen frei waehlbar - es muss nur mit einem Unterstrich (_) enden!<br />
        		(Dokumentation Siehe Plugin-Verzeichnis!)",
            // Name des Autors
            "piepstachel, Migration nach 2.0: Bechti",
            // Download-URL
            "www.mozilo.de",
            // Platzhalter fr die Selectbox in der Editieransicht
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            array(
                '{FLEXSIDEBAR}' => 'Kurzbeschreibung',
                '{FLEXSIDEBAR|}' => 'Kurzbeschreibung'
            )
        );
        // Rckgabe der Infos.
        // Auch hier knnte man die Inhalte natrlich von der aktuell im Admin eingestellten
        // Sprache abhngig machen - siehe getConfig().
        return $info;

    } // function getInfo

} // class MR_SIDEBAR

?>