<?php if(!defined('IS_CMS')) die();


class LayoutSwitcher extends Plugin {

// -----------------------------------------------------------------------------
    function getContent($value) { 
        global $CMS_CONF;
        global $specialchars;
        # Plugin ausführen bevor irgend was anders läuft ist unabhängig vom Platzhalter
        if($value == "plugin_first") {
            # wir arbeiten einfach mit session um das layout zu speichern
            # wenns die noch nicht gibt mit default füllen
            if(!isset($_SESSION["LayoutSwitcherLayout"]))
                $_SESSION["LayoutSwitcherLayout"] = $CMS_CONF->get("cmslayout");
            # ein layout wurde ausgewählt
            if(getRequestValue('layout','get',false))
                $_SESSION["LayoutSwitcherLayout"] = $specialchars->replaceSpecialChars(getRequestValue('layout','get',false),false);
            # wenn das layout das gleiche ist wie bereits (im admin) konfiguriert, nichts machen
            if($_SESSION["LayoutSwitcherLayout"] == $CMS_CONF->get("cmslayout"))
                return;
            # variable holen die fürs layout wichtig sind und überschreiben
            global $LAYOUT_DIR, $TEMPLATE_FILE, $LAYOUT_DIR_URL, $template;
            $LAYOUT_DIR     = LAYOUT_DIR_NAME."/".$_SESSION["LayoutSwitcherLayout"];
            $TEMPLATE_FILE  = $LAYOUT_DIR."/template.html";
            $LAYOUT_DIR_URL = $specialchars->replaceSpecialChars(URL_BASE.$LAYOUT_DIR,true);
            # das set ist nur temporär in dieser sitzung da wir im frontend sind
            # wird nichts in die conf geschrieben sondern nur das array geändert
            $CMS_CONF->set("cmslayout",$_SESSION["LayoutSwitcherLayout"]);
            # neues template einlesen
            $template = getTemplate($TEMPLATE_FILE);
            return;
        }
        # ab hier ist der eigendliche Pluginplatzhalter aufruf
        global $CatPage;
        # Array mit vorhandenen Layouts erstellen und ins DropDown auslesen
        $LayoutArray = getDirAsArray(BASE_DIR."layouts/", "dir");
        if(count($LayoutArray) < 1)
            return NULL;

        # HTML-Ausgabe erstellen
        # bewußt mit GET, damit man einen Link auf eine Site direkt mit einem konkretem Layout aufrufen kann
        $HTMLContent = '<form method="get" action="'.$CatPage->get_Href(CAT_REQUEST,PAGE_REQUEST).'" accept-charset="'.CHARSET.'" class="layoutswitcher">'."\n";
        if($CMS_CONF->get("modrewrite") != "true") {
            $HTMLContent .= '<input type="hidden" name="cat" value="'.CAT_REQUEST.'" />'."\n";
            $HTMLContent .= '<input type="hidden" name="page" value="'.PAGE_REQUEST.'" />'."\n";
        }
        $AutoSubmitCMD = "";
        if ($this->settings->get("AutoSubmitJS") == "true")
            $AutoSubmitCMD = ' onchange="this.form.submit();"';

        $HTMLContent .= '<select name="layout" size="1"'.$AutoSubmitCMD.'>'."\n";

        # Array mit vorhandenen Layouts erstellen und ins DropDown auslesen
        $LayoutArray = getDirAsArray(BASE_DIR."layouts/", "dir");
        natcasesort($LayoutArray);
        foreach($LayoutArray as $LayoutName) {
            $Selected = "";
            if ($LayoutName == $_SESSION["LayoutSwitcherLayout"])
                $Selected = ' selected="selected"';
            $HTMLContent .= '<option'.$Selected.' value="'.$LayoutName.'">';
            $HTMLContent .= $specialchars->rebuildSpecialChars($LayoutName, true, true);
            $HTMLContent .= "</option>\n";
        }
        $HTMLContent .= "</select><br />\n";
        $HTMLContent .= '<input type="submit" value=" '.$this->settings->get("ButtonText").' " />'."\n";
        $HTMLContent .= "</form>\n";

        if($this->settings->get("FormularHTML")) {
            # Wenn HTML-Feld befüllt ist      
            $FormularHTML = $this->settings->get("FormularHTML");
            # Weil die Zeilenumbrüche aus dem HTML-Textfeld autom. als <br /> in die plugin.conf
            # gespeichert werden, müssen diese hier in \n gewandelt werden.
            $FormularHTML = str_replace("<br />", "\n", $FormularHTML);
            # Und nun die vom Benutzer im HTML-Textfeld eingegebenen <br>
            # ins XHTML konformes <br /> wandlen.
            $FormularHTML = str_replace("<br>", "<br />", $FormularHTML);
            $HTMLContent = str_replace("{FormularPlatzhalter}", $HTMLContent, $FormularHTML);
        }
        return $HTMLContent;
    }

// -----------------------------------------------------------------------------
    function getConfig() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
        $config = array();
        if(IS_ADMIN and $this->settings->get("plugin_first") !== "true") {
            $this->settings->set("plugin_first","true");
        }
        $config['deDE']['FormularHTML'] = array(
            "type" => "textarea",
            "cols" => "45",
            "rows" => "7",
            "description" => "Eigenes HTML<br />(Zeilenumbruch sind als &lt;br&gt; anzugeben)",
        );
        $config['deDE']['ButtonText']  = array(
            "type" => "text",
            "description" => "Button-Text",
            "maxlength" => "20",
            "size" => "30",
            );
        $config['deDE']['AutoSubmitJS'] = array(
            "type" => "checkbox",
            "description" => "Formular nach Auswahl autom.<br />absenden (erfordert JavaScript)"
        );
        if(isset($config[$language])) {
          return $config[$language];
        } else {
          return $config['deDE'];
        }
    }

// -----------------------------------------------------------------------------
    function getInfo() {
      global $ADMIN_CONF;
      $language = $ADMIN_CONF->get("language");
      $info['deDE'] = array(
          // Plugin-Name
          "<b>LayoutSwitcher</b> 1.6",
          // CMS-Version
          "2.0",
          // Kurzbeschreibung
          'Erstellt ein Formular zum Umschalten des Layouts.<br />
          <br />
          <span style="font-weight:bold;">Aufruf im CMS:</span><br />
          An der gewünschten Stelle mittels {LayoutSwitcher}<br />
          <br />
          <span style="font-weight:bold;">Layout CSS:</span><br />
          Zentral in der Datei "plugins/LayoutSwitcher/plugin.css" 
          (diese wird - wenn vorhanden - autom. von moziloCMS eingebunden),
          oder in jedem einzelnen Layout in der style.css.<br />
          Die CSS-Klasse des Formulars heisst ".layoutswitcher".<br />
          <br />
          <span style="font-weight:bold;">Ausgabe mit HTML:</span><br />
           Im Feld unten kann eigener HTML-Code rund um das Switcher-Form gebaut werden.
           Anstelle des generierten Switcher-Form ist in diesem Feld der Platzhalter {FormularPlatzhalter} anzugeben.
           Wenn ansonsten nur das generierte Switcher-Formular ohne eigenes HTML rundherum gewünscht wird,
          ist das Feld unten leer zu lassen.<br />
          <br />
          <span style="font-weight:bold;">Info:</span><br />
          Ab mozilo 2.0 arbeitet dieses Plugin mit Sessions, damit gilt das ausgewählte Layout 
          nur für die jeweilige Browsersitzung. Beim ersten Aufruf wird immer das im Admin eingestellte Layout angezeigt, 
          der Link direkt nach Auswahl kann benutzt werden, um die Seite direkt im jeweiligen Layout aufzurufen.
          <br />',
          // Name des Autors
          "hausl78",
          // Download-URL
          "http://www.mozilo.de/",
        array(
        '{LayoutSwitcher}' => 'Erzeugt das LayoutSwitcher Form')
        );
      if(isset($info[$language])) {
          return $info[$language];
      } else {
          return $info['deDE'];
      }
    }
}
?>