<?php

/***************************************************************
*
* Plugin MenuCSSCount für moziloCMS.
* 
* Erstellt ein Menü mit einer eigenen CSS-Klasse 
* je Menüpunkt, die immer um 1 hochgezählt wird.
* li.mainmenu1, li.mainmenu2, ...
* 
***************************************************************/


class MenuCSSCount extends Plugin {

// ----------------------------------------------------------------------
    function getContent($value) { 
        global $CMS_CONF;
        global $CatPage;
        global $syntax;
       
        $menuCount = 1;
        $mainmenu = '<ul class="mainmenu">';
        // Kategorien-Verzeichnis einlesen
        $categoriesarray = $CatPage->get_CatArray();
        // Jedes Element des Arrays ans Menue anhaengen
        foreach ($categoriesarray as $currentcategory) {
            $mainmenu .= '<li class="mainmenu'.$menuCount.'">'
                .$CatPage->create_AutoLinkTag($currentcategory,false,"menu");
            if($CatPage->is_Activ($currentcategory,false)
                    and $CMS_CONF->get("usesubmenu") > 0) {
                $mainmenu .= $syntax->getDetailMenu($currentcategory);
            } elseif(!$CatPage->is_Activ($currentcategory,false)
                    and $CMS_CONF->get("usesubmenu") == 2) {
                $mainmenu .= getDetailMenu($currentcategory);
            }
            $mainmenu .= "</li>";
            $menuCount ++;
        }
        // Rueckgabe des Menues
        return $mainmenu . "</ul>";        
    }


// ----------------------------------------------------------------------
    function getConfig() {
    }


// ----------------------------------------------------------------------
    function getInfo() {
      global $ADMIN_CONF;
      $language = $ADMIN_CONF->get("language");
        
      $info['deDE'] = array(
          // Plugin-Name
          "<b>MenuCSSCount</b> 2.1",
          // CMS-Version
          "2.0",
          // Kurzbeschreibung
          ' Erstellt das Menü mit einer eigenen CSS-Klasse je Hauptmenüpunkt,
          die immer um 1 hochgezählt wird (mainmenu1, mainmenu2, etc ...). 
          So kann jedem Hauptmenüpunkt eine unterschiedliche CSS-Klasse zugewiesen werden.<br /> 
          <br /> 
          <span style="font-weight:bold;">Aufruf:</span><br />
          Template wo das Menü hinkommen soll mittels: {MenuCSSCount}<br />
          <br />',
          // Name des Autors
          "hausl78",
          // Download-URL
          "http://www.mozilo.de/forum/index.php?action=media;sa=album;in=6",
        array('{MenuCSSCount}' => 'Erstellt Menü mit CSS-Klasse je Menüpunkt')
        );

      if(isset($info[$language])) {
          return $info[$language];
      } else {
          return $info['deDE'];
      }
    }

}
?>