<?php if(!defined('IS_CMS')) die();

class MenuSubsImage extends Plugin {
    private $breadcrumb_delimiter = "";
    private $menu2 = false;

    private $para = false;
    private $head_css = '';
    private $imgCss = array();

    public function getDefaultSettings() {
        return array(
            "plugin_first" => "true",
            "menusubs_2" => "no_menusubs_2",
            "sitemap_show_menu2" => "false",
            "breadcrumb_delimiter" => "",
            "cat_activ" => "false",
            "subcat_activ" => "false",
            "page_activ" => "false"
        );
    }

    public function getContent($value) {
        global $CatPage;

        if($value == "plugin_first" and getRequestValue('action', 'get') and getRequestValue('action', 'get') == "sitemap") {
            define("ACTION_CONTENT",false);
            global $pagecontent;
            $pagecontent = "{".get_class()."|sitemap_content}";
            return;
        }
#        $this->menu2 = false;
        if($value === "menusubs_2"
                and $this->settings->get("menusubs_2") != "no_menusubs_2"
                and $CatPage->exists_CatPage(replaceFileMarker($this->settings->get("menusubs_2"),false),false))
            $this->menu2 = replaceFileMarker($this->settings->get("menusubs_2"),false);

        if($value === false or $value === "main" or $value === "detail") {
/*echo "<pre>";
var_export(gd_info());
echo "</pre>";
*/
            $this->makeImagePara();
            if($value === false)
                $htm = $this->getMenuCat();
            if($value === "main")
                $htm = $this->getMenuCat(true);
            if($value === "detail") {
                if(strpos(CAT_REQUEST,"%2F") > 1) {
                    $tmp_cat = explode("%2F",CAT_REQUEST);
                    $htm = $this->getMenuPage($tmp_cat[0]);
                } else
                    $htm = $this->getMenuPage(CAT_REQUEST);
            }
            $this->makeCss();
            return  $htm;
        }
        if($this->menu2 and $value === "menusubs_2")
            return $this->getMenuPage($this->menu2,false,true);
        if($value === "sitemap_content")
            return $this->getSitemapCat();
        if($value === "breadcrumb") {
            $this->breadcrumb_delimiter = "»";
            if($this->settings->get("breadcrumb_delimiter"))
                $this->breadcrumb_delimiter = $this->settings->get("breadcrumb_delimiter");
            return $this->getBreadcrumb();
        }
        return NULL;
    }

    private function getMenuCat($only_main = false) {
        global $CatPage, $CMS_CONF;
        $return = false;
        $css = "cat-menusubs-link menusubs-link";
        $ul = '<ul class="cat-menusubs">';
        $catN = 1;
        foreach($CatPage->get_CatArray() as $cat) {
            if(strpos($cat,"%2F") > 1) continue;
            if($this->menu2 and $this->menu2 == $cat)
                continue;

            if($CatPage->get_Type($cat,false) == EXT_LINK) {
                $ul .= '<li class="cat-menusubs cat'.$catN.'">'.$CatPage->create_AutoLinkTag($cat,false,$css).'</li>';
                $this->makeImage('cat',$cat,false,$catN);
                $return = true;
            } elseif($CatPage->get_Type($cat,false) == "cat") {
                $cssactiv = "";
                $activ = false;
                if(!$CatPage->is_Activ($cat,false) and strstr(CAT_REQUEST,$cat."%2F")) {
                    $activ = true;
                    $cssactiv = "active";
                } elseif($CatPage->is_Activ($cat,false))
                    $activ = true;
                $ul .= '<li class="cat-menusubs cat'.$catN.'">'.$CatPage->create_AutoLinkTag($cat,false,$css.$cssactiv);
                $this->makeImage('cat',$cat,$activ,$catN);
                if(!$only_main and ($activ or $CMS_CONF->get("usesubmenu") == 2))
                    $ul .= $this->getMenuPage($cat,false,false,$catN,1);
                $ul .= '</li>';
                $return = true;
            }
            $catN++;
        }
        if($return)
            return $ul.'</ul>';
        return null;
    }

    private function getMenuPage($cat,$subcat = false,$menu_2 = false,$catN = 0,$subN = 1) {
        global $CatPage, $CMS_CONF;
        $return = false;

        $ul = '<ul class="page-menusubs subcat'.$catN.' sub'.$subN.'">';
        if($subcat)
            $ul = '<ul class="subcat-menusubs subcat'.$catN.' sub'.$subN.'">';

        if($menu_2)
            $ul = '<ul class="cat-menusubs menusubs2">';
        $pageN = 1;
        foreach($CatPage->get_PageArray($cat,array(EXT_PAGE,EXT_HIDDEN,EXT_LINK)) as $page) {
            if(strpos($cat,"%2F") > 1
                    and $CMS_CONF->get("hidecatnamedpages") == "true"
                    and substr($cat,(strrpos($cat,"%2F") + 3)) == $page)
                continue;
            if($CatPage->get_Type($cat,$page) == EXT_LINK) {
                $ul .= '<li class="page-menusubs page'.$pageN.'">'.$CatPage->create_AutoLinkTag($cat,$page,"page-menusubs-link menusubs-link").'</li>';
                $this->makeImage('page',$page,false,$catN,$pageN,$subN);
                $return = true;
                continue;
            }
            if(strpos($page,"%2F") > 1
                    and $CatPage->get_Type($cat,$page) == EXT_HIDDEN
                    and $CatPage->get_Type($page,false) == "cat"
                    and count($CatPage->get_PageArray($page,array(EXT_PAGE,EXT_HIDDEN,EXT_LINK))) > 0) {
                $ul .= '<li class="subcat-menusubs page'.$pageN.'">'.($sub = $this->create_CatSubLinkTag($cat,$page,"subcat-menusubs-link menusubs-link"));
                $text = strip_tags($sub);
                if(strpos($sub,"menusubs-linkactive"))
                    $this->makeImage('subcat',$text,true,$catN,$pageN,$subN);
                else
                    $this->makeImage('subcat',$text,false,$catN,$pageN,$subN);
                $sub = $subN;
                $sub++;
                if(strstr(CAT_REQUEST,$page) or $CMS_CONF->get("usesubmenu") == 2)
                    $ul .= $this->getMenuPage($page,true,false,$catN,$sub);
                $ul .= '</li>'."\n";
                $return = true;
            } elseif($CatPage->get_Type($cat,$page) != EXT_HIDDEN) {
                if($CatPage->get_Type($cat,$page) == EXT_LINK)
                    continue;
                $ul .= '<li class="page-menusubs page'.$pageN.'">'.($sub = $CatPage->create_AutoLinkTag($cat,$page,"page-menusubs-link menusubs-link")).'</li>';
                if(strpos($sub,"menusubs-linkactive"))
                    $this->makeImage('page',$page,true,$catN,$pageN,$subN);
                else
                    $this->makeImage('page',$page,false,$catN,$pageN,$subN);
                $return = true;
            }
            $pageN++;
        }
        if($return)
            return $ul.'</ul>';
        return null;
    }

    private function makeCss() {
        if(count($this->imgCss) < 1)
            return;

        global $syntax;

        foreach($this->imgCss as $sub) {
            $css = '';
            $dst_im = imagecreatetruecolor($sub['max']['w'],$sub['max']['h']);
            imagealphablending($dst_im, false);
            imagesavealpha($dst_im, true);
            foreach($sub as $img) {
                foreach(array('normal','activ','hover') as $status) {
                    if(isset($img[$status])) {
                        $align = 0;
                        if($this->para[$img[$status]['art']]['horizontal'] == "right")
                            $align = $sub['max']['w'] - $img[$status]['w'];
                        elseif($this->para[$img[$status]['art']]['horizontal'] == "center")
                            $align = ($sub['max']['w'] - $img[$status]['w']) / 2;
                        imagecopy($dst_im , $img[$status]['img'], $align, $img[$status]['y'], 0, 0, $sub['max']['w'] , $img[$status]['h'] );
                        imagedestroy($img[$status]['img']);

                        $css .= $img[$status]['css'].' {background-position:'.$this->para[$img[$status]['art']]['horizontal'].' -'.$img[$status]['y'].'px;'
                        .'width:'.$img[$status]['w'].'px;'
                        .'height:'.$img[$status]['h'].'px;';
                        if($status != "hover")
                            $css .= 'padding:0 !important;';
                        $css .= '}'."\n";
                    }
                }
            }
            ob_start();
                imagepng($dst_im);
                $bild = 'data:image/png;base64,'.base64_encode(ob_get_contents());
            ob_end_clean();
            imagedestroy($dst_im);
            $syntax->insert_in_head('<style type="text/css">'.$sub['max']['css'].' {background-image:url("'.$bild.'");'."\n".'background-repeat:no-repeat;text-indent:-9999px;}</style>');
            $syntax->insert_in_head('<style type="text/css">'.$css.'</style>');
        }
        $this->imgCss = array();
    }

    private function makeImage($art,$text,$activ,$catN,$pageN = 0,$subN = 0) {
        if(false === $this->para or false === $this->para[$art])
            return;
        global $specialchars;
        $text = $specialchars->rebuildSpecialChars($specialchars->getHtmlEntityDecode($text), false, false);
        if($activ and $this->para[$art]['activ'])
            $this->getImage($art,'activ',$text,$catN,$pageN,$subN);
        elseif($this->para[$art]['normal'])
            $this->getImage($art,'normal',$text,$catN,$pageN,$subN);

        if($this->para[$art]['hover'])
            $this->getImage($art,'hover',$text,$catN,$pageN,$subN);
    }

    private function getImage($art,$status,$text,$catN,$pageN,$subN) {

        $im = imagecreatefrompng($this->para[$art][$status]['img']);
        $this->para[$art][$status]['imgWidth'] = imagesx($im);
        $this->para[$art][$status]['imgHeight'] = imagesy($im);
        imagesavealpha($im, true);

        list($im,$width,$height) = $this->TextWrapAndAlign($im,$art,$status,$text,$subN);

        if(!isset($this->imgCss[$subN])) {
            $this->imgCss[$subN]['max']['w'] = $width;
            $this->imgCss[$subN]['max']['h'] = 0;
        }

        $hover = '';
        if($status == "hover")
            $hover = ':hover';
        $this->imgCss[$subN][][$status] = array('img' => $im,
                                                'y' => $this->imgCss[$subN]['max']['h'],
                                                'h' => $height,
                                                'w' => $width,
                                                'css' => ($subN ? 'ul.subcat'.$catN.'.sub'.$subN.' > .page'.$pageN.' > a'.$hover : 'li.cat'.$catN.' > a'.$hover),
                                                'art' => $art);

        $is_active = "";
        if(!$this->para['subcat'] and $this->para['page'])
            $is_active = ".page-menusubs-link";
        if($this->para['subcat'] and !$this->para['page'])
            $is_active = ".subcat-menusubs-link";

        $this->imgCss[$subN]['max'] = array('w' => max($this->imgCss[$subN]['max']['w'],$width),
                                            'h' => ($this->imgCss[$subN]['max']['h'] += $height),
                                            'css' => ($subN ? 'ul.sub'.$subN.' > li > a'.$is_active : 'ul.cat-menusubs > li.cat-menusubs > a'));
    }

    private function TextWrapAndAlign($im,$art,$status,$text,$subN) {
        $box_n = array_fill(0, 8, 0);
        $bbox = array_reverse($this->linesBox($art,$status,$text,$subN));
        $textHeight = 0;

        $left = false;
        $top = false;
        $top_of = 0;
        $left_of = 0;
        $of_l = ($this->para[$art]['lineHeight'] - $this->para[$art]['fontSize']) * $this->para[$art]['angel_sin'];
        $of_t = ($this->para[$art]['lineHeight'] - $this->para[$art]['fontSize']) * $this->para[$art]['angel_cos'];
        $of_font_l = $this->para[$art]['fontSize'] * $this->para[$art]['angel_sin'];
        $of_font_t = $this->para[$art]['fontSize'] * $this->para[$art]['angel_cos'];

        foreach($bbox as &$box) {
            $box['left'] = 0;
            $box['top'] = 0;
            $this->TextAlign($box,$art,$status,$textHeight);
            $box_n = $this->AddBbox($art,$status,$box, $box_n);
            $textHeight = $this->TextHeight($box_n);

            if($this->para[$art]['angel'] >= 0 and $this->para[$art]['angel'] < 90) {
                $left = min($box['left'] - $of_font_l - $of_l,
                            ($left !== false) ? $left : $box['left'] - $of_font_l - $of_l);
                $top = max($box['top'] + $of_t,
                           ($top !== false) ? $top : $box['top'] + $of_t);
                $left_of = $of_font_l;
            } elseif($this->para[$art]['angel'] >= 90 and $this->para[$art]['angel'] < 180) {
                $left = max($box['left'] + $of_l,
                            ($left !== false) ? $left : $box['left'] + $of_l);
                $top = max($box['top'] - $of_font_t - $of_t,
                           ($top !== false) ? $top : $box['top'] - $of_font_t - $of_t);
                $top_of = -$of_font_t;
            } elseif($this->para[$art]['angel'] >= 180 and $this->para[$art]['angel'] < 270) {
                $left = max($box['left'] - $of_font_l - $of_l,
                            ($left !== false) ? $left : $box['left'] - $of_font_l - $of_l);
                $top = min($box['top'] + $of_t,
                           ($top !== false) ? $top : $box['top'] + $of_t);
                $left_of = -$of_font_l;
            } elseif($this->para[$art]['angel'] >= 270 and $this->para[$art]['angel'] < 360) {
                $left = min($box['left'] + $of_l,
                            ($left !== false) ? $left : $box['left'] + $of_l);
                $top = min($box['top'] - $of_font_t - $of_t,
                            ($top !== false) ? $top : $box['top'] - $of_font_t - $of_t);
                $top_of = $of_font_t;
            }
        }
        list($max_w,$max_h) = $this->ClearDimensions($art,$status,$bbox,$left,$top,$left_of,$top_of);
        list($im, $maxWidth,$maxHeight) = $this->cropImage($im,$art,$status,$max_w,$max_h,$subN);
        $this->WriteTextAndAlign($im,$art,$status,$bbox,$max_w,$max_h,$maxWidth,$maxHeight);
        return array($im,$maxWidth,$maxHeight);
    }

    private function cropImage($im,$art,$status,$new_width,$new_height,$subN) {
        if(!$this->para[$art]['crop']) {
            if(!$subN)
                return array($im, $this->para[$art][$status]['imgWidth'],$this->para[$art][$status]['imgHeight']);
            return $this->helpCropImage($im,$art,$status, $this->para[$art][$status]['imgWidth'] - ($this->para[$art]['indent'] * ($subN - 1)), $this->para[$art][$status]['imgHeight'], 0, 0, 0, 0);
        }

# 0=oben, 1=rechts, 2=unten, 3=links
        if($this->para[$art]['maxWidth'] and $this->para[$art]['crop'])
            $new_width = $this->para[$art]['maxWidth'];
        elseif(!$this->para[$art]['maxWidth'] and $this->para[$art]['crop'])
            $new_width = round($new_width) + $this->para[$art]['padding'][1] + $this->para[$art]['padding'][3];

        if($this->para[$art]['maxHeight'] and $this->para[$art]['crop'])
            $new_height = $this->para[$art]['maxHeight'];
        elseif(!$this->para[$art]['maxHeight'] and $this->para[$art]['crop'])
            $new_height = round($new_height) + $this->para[$art]['padding'][0] + $this->para[$art]['padding'][2];

        if($subN)
            $new_width = $new_width - ($this->para[$art]['indent'] * ($subN - 1));

        if($new_width  <= $this->para[$art][$status]['imgWidth']) {
            # horizontal
            # left
            $d_left = 0;
            $s_left = 0;
            # center
            if($this->para[$art]['horizontal'] === "center")
                $s_left = max(0,($this->para[$art][$status]['imgWidth'] - $new_width) / 2);
            # right
            elseif($this->para[$art]['horizontal'] == "right")
                $s_left = $this->para[$art][$status]['imgWidth'] - $new_width;
        } else {
            # horizontal
            # left
            $d_left = 0;
            $s_left = 0;
            # center
            if($this->para[$art]['horizontal'] === "center")
                $d_left = max(0,($new_width - $this->para[$art][$status]['imgWidth']) / 2);
            # right
            elseif($this->para[$art]['horizontal'] == "right")
                $d_left = $new_width - $this->para[$art][$status]['imgWidth'];
        }
        if($new_height <= $this->para[$art][$status]['imgHeight']) {
            # vertikal
            # top
            $d_top = 0;
            $s_top = 0;
            # center
            if($this->para[$art]['vertical'] === "center")
                $s_top = ($this->para[$art][$status]['imgHeight'] - $new_height) / 2;
            # bottom
            elseif($this->para[$art]['vertical'] == "bottom")
                $s_top = $this->para[$art][$status]['imgHeight'] - $new_height;
        } else {
            # vertikal
            # top
            $d_top = 0;
            $s_top = 0;
            # center
            if($this->para[$art]['vertical'] === "center")
                $d_top = ($new_height - $this->para[$art][$status]['imgHeight']) / 2;
            # bottom
            elseif($this->para[$art]['vertical'] == "bottom")
                $d_top = $new_height - $this->para[$art][$status]['imgHeight'];
        }

        return $this->helpCropImage($im,$art,$status, $new_width, $new_height, $d_left, $d_top, $s_left, $s_top);
    }

    private function helpCropImage($im,$art,$status, $new_width, $new_height, $d_left, $d_top, $s_left, $s_top) {
        $canvas = imagecreatetruecolor($new_width, $new_height);
        imagealphablending($canvas, false);
        imagecopy($canvas, $im, $d_left, $d_top, $s_left, $s_top, min($this->para[$art][$status]['imgWidth'],$new_width), min($this->para[$art][$status]['imgHeight'],$new_height));
        if($new_width > $this->para[$art][$status]['imgWidth'] or $new_height > $this->para[$art][$status]['imgHeight']) {
            $transparent = imagecolorallocatealpha($canvas, 0, 0, 0, 127);
            imagefill($canvas, 0, 0, $transparent);
        }
        imagealphablending($canvas, true);
        imagesavealpha($canvas, true);
        imagedestroy($im);
        return array($canvas, $new_width, $new_height);
    }

    private function WriteTextAndAlign($im,$art,$status,&$bbox,$max_w,$max_h,$width,$height) {
        list($fontR,$fontG,$fontB,$alpha) = $this->para[$art][$status]['fontColor'];
        # 0 - 127 127=transaprent
        $fontColor = imagecolorallocatealpha($im,$fontR,$fontG,$fontB,$alpha);

        foreach($bbox as &$box) {
            if($this->para[$art]['angel'] >= 0 and $this->para[$art]['angel'] < 90)
                $box['top'] += $max_h;
            elseif($this->para[$art]['angel'] >= 90 and $this->para[$art]['angel'] < 180) {
                $box['left'] += $max_w;
                $box['top'] += $max_h;
            } elseif($this->para[$art]['angel'] >= 180 and $this->para[$art]['angel'] < 270)
                $box['left'] += $max_w ;
            # horizontal
            # left
            $left = $this->para[$art]['padding'][3];
            # center
            if($this->para[$art]['horizontal'] === "center")
                $left = ($width - $max_w) / 2;
            # right
            elseif($this->para[$art]['horizontal'] == "right")
                $left = $width - $max_w - $this->para[$art]['padding'][1];
            # vertikal
            # top
            $top = $this->para[$art]['padding'][0];
            # center
            if($this->para[$art]['vertical'] === "center")
                $top = ($height - $max_h) / 2;
            # bottom
            elseif($this->para[$art]['vertical'] == "bottom")
            $top = $height - $max_h - $this->para[$art]['padding'][2];

            $box['left'] += $left;
            $box['top'] += $top;

            imagettftext($im,$this->para[$art]['fontSize'],$this->para[$art]['angel'],$box['left'],$box['top'],$fontColor,$this->para[$art][$status]['font'],$box['text']);
        }
    }

    private function TextAlign(&$box,$art,$status,$text_height) {
        $text = $box['text'];
        $adjustment = 0;
        $box['left'] -= $text_height * $this->para[$art]['angel_sin'];
        $box['top'] -= $text_height * $this->para[$art]['angel_cos'];
        if($this->para[$art]['textalign'] != "left") {
            $text_length = $this->TextLength($box);
            $adjustment = 0;
            if($this->para[$art]['textalign'] == "center")
                $adjustment = ($this->para['maxLength'] - $text_length) / 2;
            elseif($this->para[$art]['textalign'] == "right")
                $adjustment = $this->para['maxLength'] - $text_length;
            $box['left'] += $adjustment * $this->para[$art]['angel_cos'];
            $box['top'] -= $adjustment * $this->para[$art]['angel_sin'];
        }
    }

    private function ClearDimensions($art,$status,&$bbox,$left,$top,$left_of,$top_of) {
        $max_w = 0;
        $max_h = 0;
        foreach($bbox as &$box) {
            $box['left'] -= $left;
            $box['top'] -= $top;
            $max_w = max($max_w,(abs($box['left']) + $box['width']) - $left_of);
            $max_h = max($max_h,(abs($box['top']) + $box['height']) - $top_of);
        }

        $max_w += abs(round((($this->para[$art]['lineHeight'] - $this->para[$art]['fontSize']) / 2) * $this->para[$art]['angel_cos'],12));
        $max_h += (($this->para[$art]['lineHeight'] - $this->para[$art]['fontSize']) / 2) - abs(round((($this->para[$art]['lineHeight'] - $this->para[$art]['fontSize']) / 2) * $this->para[$art]['angel_cos'],12));
        return array(round($max_w), round($max_h));
    }

    private function AddBbox($art,$status,$bbox1, $bbox2) {
        $new_length = max($this->TextLength($bbox1), $this->TextLength($bbox2));
        $new_height = $this->TextHeight($bbox1) + $this->TextHeight($bbox2);
        $bbox[0] = 0;
        $bbox[1] = 0;
        $bbox[2] = $new_length * $this->para[$art]['angel_cos'];
        $bbox[3] = $new_length * $this->para[$art]['angel_sin'];
        $bbox[6] = ($new_height + $this->para[$art]['lineSpacing']) * $this->para[$art]['angel_sin'];
        $bbox[7] = ($new_height + $this->para[$art]['lineSpacing']) * $this->para[$art]['angel_cos'];
        $bbox[4] = $bbox[2] + $bbox[6];
        $bbox[5] = $bbox[3] + $bbox[7];
        return $bbox;
    }

    private function TextLength($box) {
        return sqrt(pow(($box[2] - $box[0]),2) + pow(($box[3] - $box[1]),2));
    }

    private function TextHeight($box) {
        return sqrt(pow(($box[6] - $box[0]),2) + pow(($box[7] - $box[1]),2));
    }

    private function linesBox($art,$status,$text,$subN) {
        $lines = explode(" ",trim($text));
        $count = 0;
        $bbox = array();
        $bbox[$count]['text'] = "";
        $linesCount = count($lines);
        $maxLength = 0;
        $maxWidth = $this->para[$art][$status]['imgWidth'];
        if($this->para[$art]['maxWidth'])
            $maxWidth = $this->para[$art]['maxWidth'];

        $maxWidth -= $this->para[$art]['padding'][1] + $this->para[$art]['padding'][3];

        if($subN)
            $maxWidth -= $this->para[$art]['indent'] * ($subN - 1);

        foreach($lines as $pos => $line) {
            $space = $bbox[$count]['text'].($bbox[$count]['text'] ? " " : "");
            $box = $this->imageTextBox($art,$status, $space.$line);
            $textLength = $this->TextLength($box);
            if($linesCount > 1 and $textLength > $maxWidth) {
                if($pos > 0)
                    $count++;
                $box = $this->imageTextBox($art,$status, $line);
                $textLength = $this->TextLength($box);
                $space = "";
            }
            $maxLength = max($textLength,$maxLength);
            $bbox[$count] = $box;
            $bbox[$count]['text'] = $space.$line;
        }
        $this->para['maxLength'] = $maxLength;
        return $bbox;
    }

    private function imageTextBox($art,$status,$text) {
        $b = imagettfbbox($this->para[$art]['fontSize'],0,$this->para[$art][$status]['font'],$text);
        $b[1] = $b[5] + $this->para[$art]['lineHeight'];
        $b[3] = $b[7] + $this->para[$art]['lineHeight'];
        for($i=0; $i<4; $i++) {
            $x = $b[$i * 2];
            $y = $b[$i * 2 + 1];
            $b[$i * 2] = ($this->para[$art]['angel_cos'] * $x)
                       - ($this->para[$art]['angel_sin'] * $y);
            $b[$i * 2 + 1] = ($this->para[$art]['angel_sin'] * $x)
                           + ($this->para[$art]['angel_cos'] * $y);
        }
        $b['width'] = max($b[0],$b[2],$b[4],$b[6]) - min($b[0],$b[2],$b[4],$b[6]);
        $b['height'] = max($b[1],$b[3],$b[5],$b[7]) - min($b[1],$b[3],$b[5],$b[7]);
        return $b;
    }


/*
    function HEXtoRGB($hexStr) {
        if($hexStr[0] == "#")
            $hexStr = substr($hexStr, 1);
        if(strlen($hexStr) == 3)
            $hexStr = str_repeat(substr($hexStr, 0, 1),2)
                     .str_repeat(substr($hexStr, 1, 1),2)
                     .str_repeat(substr($hexStr, 2, 1),2);
        if(strlen($hexStr) != 6)
            return array(0,0,0);
        $colorVal = hexdec($hexStr);
        return array((0xFF & ($colorVal >> 0x10)),
                     (0xFF & ($colorVal >> 0x8)),
                     (0xFF & $colorVal));
    }
*/
    private function create_CatSubLinkTag($cat,$page,$css) {
        global $specialchars, $CatPage, $language;
        $cssactiv = "";
        if(strstr(CAT_REQUEST,$page))
            $cssactiv = "active";
        $text = $CatPage->get_HrefText($page,false);
        $text = substr($text,(strrpos($text,"/")));
        if($text[0] == "/")
            $text = substr($text,1);
        return $CatPage->create_LinkTag(
                $CatPage->get_Href($page,false),
                $text,
                $css.$cssactiv,
                $language->getLanguageHtml("tooltip_link_category_1", $CatPage->get_HrefText($page,false)));
    }

    private function getBreadcrumb() {
        global $CatPage, $CMS_CONF;
        $css = "";
        $ul = '<ul class="menusubs-breadcrumb">';
        $ul .= '<li class="menusubs-breadcrumb-home"><a href="{BASE_URL}" title="Home">Home</a></li>';

        foreach($CatPage->get_CatArray() as $cat) {
            if($CatPage->get_Type($cat,false) == "cat" and $CatPage->is_Activ($cat,false)) {
                if(strpos($cat,"%2F") > 1) {
                    $cats = explode("%2F",$cat);
                    $linkcat = "";
                    foreach($cats as $ca) {
                        $linkcat .= "%2F".$ca;
                        $ul .= '<li>'.$this->breadcrumb_delimiter.$this->create_BreadcrumbLinkTag($linkcat,$ca,"").'</li>';
                    }
                } else {
                        $ul .= '<li>'.$this->breadcrumb_delimiter.$CatPage->create_AutoLinkTag($cat,false,"").'</li>';
                }
                $ul .= $this->getBreadcrumbPage($cat);
            }
        }
        return $ul.'</ul>';
    }

    private function getBreadcrumbPage($cat,$subcat = false,$menu_2 = false) {
        global $CatPage, $CMS_CONF;
        $ul = '';
        foreach($CatPage->get_PageArray($cat,array(EXT_PAGE,EXT_HIDDEN)) as $page) {
            if(strpos($cat,"%2F") > 1
                    and $CMS_CONF->get("hidecatnamedpages") == "true"
                    and substr($cat,(strrpos($cat,"%2F") + 3)) == $page)
                continue;
            if(strpos($page,"%2F") > 1
                    and $CatPage->get_Type($cat,$page) == EXT_HIDDEN
                    and $CatPage->get_Type($page,false) == "cat") {
                if($CatPage->is_Activ($cat,$page))
                    $ul .= '<li>'.$this->breadcrumb_delimiter.$this->create_CatSubLinkTag($cat,$page,"").'</li>';
                if(strstr(CAT_REQUEST,$page))
#                if($CatPage->is_Activ($cat,$page))
                    $ul .= $this->getBreadcrumbPage($page,true);
            } elseif($CatPage->get_Type($cat,$page) != EXT_HIDDEN and $CatPage->is_Activ($cat,$page)) {
                if($CMS_CONF->get("hidecatnamedpages") == "true" and $cat == $page)
                    continue;
                $ul .= '<li>'.$this->breadcrumb_delimiter.$CatPage->create_AutoLinkTag($cat,$page,"").'</li>';
            }
        }
        return $ul.'';
    }

    private function create_BreadcrumbLinkTag($cat,$page,$css) {
        global $specialchars, $CatPage, $language;
        $cssactiv = "";
        $cat = substr($cat,3);
        return $CatPage->create_LinkTag(
                $CatPage->get_Href($cat,false),
                $specialchars->rebuildSpecialChars($page,true,true),
                $css.$cssactiv,
                $language->getLanguageHtml("tooltip_link_category_1", $page));
    }

    private function getSitemapCat() {
        global $CatPage, $CMS_CONF, $language;
        $return = false;
        $menu_2 = "";
        $include_pages = array(EXT_PAGE);
        if($CMS_CONF->get("showhiddenpagesinsitemap") == "true") {
            $include_pages = array(EXT_PAGE,EXT_HIDDEN);
        }
        $sitemap = '<h1 id="menusubs-sitemap-title">'.$language->getLanguageValue("message_sitemap_0")."</h1>"
                    .'<div class="sitemap" id="menusubs-sitemap">';
        foreach($CatPage->get_CatArray(false, false, $include_pages) as $cat) {
            if(strpos($cat,"%2F") > 1) continue;
            if($this->settings->get("menusubs_2") == $cat) {
                if($this->settings->get("sitemap_show_menu2") == "true") {
                    $menu_2 = '<h2>'.$CatPage->get_HrefText($cat,false).'</h2>';
                    $menu_2 .= $this->getSitemapPage($cat,true);
                    $return = true;
                }
                continue;
            }
            if($CatPage->get_Type($cat,false) == "cat") {
                $sitemap .= '<h2>'.$CatPage->create_AutoLinkTag($cat,false,"").'</h2>';
                $sitemap .= $this->getSitemapPage($cat);
                $return = true;
            }
        }
        if($return)
            return $sitemap.$menu_2.'</div>';
        return null;
    }

    private function getSitemapPage($cat,$menu2 = false) {
        global $CatPage, $CMS_CONF;
        $return = false;
        $sitemap = '<ul>';
        if($menu2)
            $sitemap = '<ul id="menusubs-sitemap-menu2">';
        foreach($CatPage->get_PageArray($cat,array(EXT_PAGE,EXT_HIDDEN)) as $page) {
            if(strpos($cat,"%2F") > 1
                    and $CMS_CONF->get("hidecatnamedpages") == "true"
                    and substr($cat,(strrpos($cat,"%2F") + 3)) == $page)
                continue;
            if(strpos($page,"%2F") > 1
                    and $CatPage->get_Type($cat,$page) == EXT_HIDDEN
                    and $CatPage->get_Type($page,false) == "cat") {
                $return = true;
                $sitemap .= '<li><h3>'.$this->create_CatSubLinkTag($cat,$page,"").'</h3>';
                $sitemap .= $this->getSitemapPage($page);
                $sitemap .= '</li>'."\n";
            } elseif($CatPage->get_Type($cat,$page) != EXT_HIDDEN) {
                $sitemap .= '<li>'.$CatPage->create_AutoLinkTag($cat,$page,"").'</li>';
                $return = true;
            }
        }
        if($return)
            return $sitemap.'</ul>';
        return null;
    }

    private function makeImagePara() {
        if(!function_exists("imagettfbbox") and !function_exists("ob_get_contents"))
            return;
        $test_string = "[JWgyl";
        $this->para = array();
        foreach(array('cat','subcat','page') as $art) {
            if($this->settings->get($art."_activ") != "true") {
                $this->para[$art] = false;
                continue;
            }
            $this->para[$art] = array();
            $status_array = array('normal','activ','hover');
            foreach(array('img','fontColor','font','fontSize','angel','maxWidth','maxHeight','textalign','horizontal','vertical','lineSpacing','padding','crop','indent') as $conf) {
                $para = $this->settings->get($art."_".$conf);
                if(in_array($conf,array('img','fontColor','font'))) {
                    foreach($status_array as $status) {
                        $para = $this->settings->get($art."_".$conf."_".$status);
                        if($conf == 'img' and is_file($para))
                            $this->para[$art][$status][$conf] = $para;
                        elseif($conf == 'fontColor') {
                            $rgba = explode(",",$para);
                            if(count($rgba) == 4)
                                $this->para[$art][$status][$conf] = array($rgba[0],$rgba[1],$rgba[2],$rgba[3]);
                        } elseif($conf == 'font' and is_file($para))
                            $this->para[$art][$status][$conf] = $para;
                        else {
                            unset($status_array[array_search($status, $status_array)]);
                            $this->para[$art][$status] = false;
                        }
                    }
                } elseif(in_array($conf,array('fontSize','angel','maxWidth','maxHeight','lineSpacing','indent'))) {
                    $this->para[$art][$conf] = 0;
                    if(is_numeric($para))
                        $this->para[$art][$conf] = $para;
                    if($conf == "angel" and $this->para[$art][$conf] >= 360)
                        $this->para[$art][$conf] = $this->para[$art][$conf] % 360;
                } elseif(in_array($conf,array('textalign','horizontal','vertical')) 
                        and in_array($para,array('center','left','right','top','bottom'))) {
                    $this->para[$art][$conf] = $para;
                } elseif($conf == "crop") {
                    $this->para[$art][$conf] = false;
                    if($para == "true")
                        $this->para[$art][$conf] = true;
                } elseif($conf == 'padding') {
                    $padding = explode(",",$para);
                    $this->para[$art][$conf] = array(0,0,0,0);
                    if(count($padding) == 1)
                        $this->para[$art][$conf] = array_pad($padding, 4, $padding[0]);
                    elseif(count($padding) == 2)
                        $this->para[$art][$conf] = array_merge($padding,$padding);
                    elseif(count($padding) == 4)
                        $this->para[$art][$conf] = $padding;
                } else {
                    $this->para[$art] = false;
                    break;
                }
            }

            if($this->para[$art]) {
                if(!$this->para[$art]['normal'] or !$this->para[$art]['activ'])
                    $this->para[$art] = false;
                else {
                    $angel_rad = $this->para[$art]['angel'] * pi() / 180;
                    $this->para[$art]['angel_sin'] = sin($angel_rad);
                    $this->para[$art]['angel_cos'] = cos($angel_rad);
                    $this->para[$art]['lineHeight'] = 0;
                    foreach(array('normal','activ','hover') as $status) {
                        if($this->para[$art][$status]) {
                            $box = imagettfbbox($this->para[$art]['fontSize'], 0, $this->para[$art][$status]['font'], $test_string);
                            $this->para[$art]['lineHeight'] = $this->TextHeight($box);
                        }
                    }
                }
            }
        }
    }

    public function getConfig() {
        global $ADMIN_CONF;
        global $CatPage;
        if(IS_ADMIN and $this->settings->get("plugin_first") !== "true") {
            $this->settings->set("plugin_first","true");
        }
        if(file_exists($this->PLUGIN_SELF_DIR."lang/conf_".$ADMIN_CONF->get("language").".txt"))
            $conf_txt = new Properties($this->PLUGIN_SELF_DIR."lang/conf_".$ADMIN_CONF->get("language").".txt");
        else
            $conf_txt = new Properties($this->PLUGIN_SELF_DIR."lang/conf_deDE.txt");

        // Das muß auf jeden Fall geschehen!
        $config = array();
        $descriptions = array("no_menusubs_2" => $conf_txt->get("no_menusubs_2"));
        $cat_array = $CatPage->get_CatArray(false,false,array(EXT_PAGE,EXT_HIDDEN));
        foreach($cat_array as $cat) {
            if(strpos($cat,"%2F") !== false) continue;
            $descriptions[FILE_START.$cat.FILE_END] = $CatPage->get_HrefText($cat, false);
        }
        $config['menusubs_2'] = array(
            "type" => "select",
            "description" => $conf_txt->get("menusubs_2"),
            "descriptions" => $descriptions,
            "multiple" => "false"
            ); 
        $config['sitemap_show_menu2'] = array(
            "type" => "checkbox",
            "description" => $conf_txt->get("sitemap_show_menu2")
        );
        $config['breadcrumb_delimiter'] = array(
            "type" => "text",
            "maxlength" => "10",
            "size" => "10",
            "description" => $conf_txt->get("breadcrumb")
        );

        if(!is_dir($this->PLUGIN_SELF_DIR.'font'))
            mkdirMulti($this->PLUGIN_SELF_DIR.'font');
        $font = array("false" => "None");
        foreach(getDirAsArray($this->PLUGIN_SELF_DIR.'font',array(".ttf",".otf")) as $value) {
            $font[$this->PLUGIN_SELF_DIR.'font/'.$value] = substr($value,0,-4);
        }
 
        if(!is_dir($this->PLUGIN_SELF_DIR.'image'))
            mkdirMulti($this->PLUGIN_SELF_DIR.'image');
        $img = array("false" => "None");
        foreach(getDirAsArray($this->PLUGIN_SELF_DIR.'image',array(".png")) as $value) {
            $img[$this->PLUGIN_SELF_DIR.'image/'.$value] = substr($value,0,-4);
        }

        $plugin_name = get_class();
        foreach(array('cat','subcat','page') as $art) {
            foreach(array('normal','activ','hover') as $status) {
                $config[$art.'_img_'.$status] = array(
                        "type" => "select",
                        "description" => '',
                        "descriptions" => $img,
                        "multiple" => "false"
                    );
                $config[$art.'_font_'.$status] = array(
                        "type" => "select",
                        "description" => '',
                        "descriptions" => $font,
                        "multiple" => "false"
                    );
                $config[$art.'_fontColor_'.$status] = array(
                        "type" => "text",
                        "maxlength" => "15",
                        "size" => "15",
                        "description" => '',
                        "regex" => "/^((\d{1,2})|([1]{1}\d{2})|([2]{1}[0-5]{1}[0-5]{1}))[,]{1}((\d{1,2})|([1]{1}\d{2})|([2]{1}[0-5]{1}[0-5]{1}))[,]{1}((\d{1,2})|([1]{1}\d{2})|([2]{1}[0-5]{1}[0-5]{1}))[,]{1}((\d{1,2})|([1]{1}[0-2]{1}[0-7]{1}))$/",
                        "regex_error" => $conf_txt->get('error_4')
                    );
            }
            $config[$art.'_activ'] = array(
                    "type" => "checkbox",
                    "description" => '',
                );

            $config[$art.'_fontSize'] = array(
                    "type" => "text",
                    "maxlength" => "3",
                    "size" => "3",
                    "description" => '',
                    "regex" => "/^\d{1,3}$/",
                    "regex_error" => $conf_txt->get('error_2')
                );
            $config[$art.'_lineSpacing'] = array(
                    "type" => "text",
                    "maxlength" => "3",
                    "size" => "3",
                    "description" => '',
                    "regex" => "/^\d{1,3}$/",
                    "regex_error" => $conf_txt->get('error_2')
                );
            $config[$art.'_angel'] = array(
                    "type" => "text",
                    "maxlength" => "3",
                    "size" => "3",
                    "description" => '',
                    "regex" => "/^\d{1,3}$/",
                    "regex_error" => $conf_txt->get('error_2')
                );
            $config[$art.'_maxWidth'] = array(
                    "type" => "text",
                    "maxlength" => "4",
                    "size" => "4",
                    "description" => '',
                    "regex" => "/^\d{1,4}$/",
                    "regex_error" => $conf_txt->get('error_3')
                );
            $config[$art.'_maxHeight'] = array(
                    "type" => "text",
                    "maxlength" => "4",
                    "size" => "4",
                    "description" => '',
                    "regex" => "/^\d{1,4}$/",
                    "regex_error" => $conf_txt->get('error_3')
                );
            $config[$art.'_padding'] = array(
                    "type" => "text",
                    "maxlength" => "15",
                    "size" => "15",
                    "description" => '',
                    "regex" => "/^\d{1,3}[,]{1}\d{1,3}[,]{1}\d{1,3}[,]{1}\d{1,3}$/",
                    "regex_error" => $conf_txt->get('error_1')
                );
            $config[$art.'_crop'] = array(
                    "type" => "checkbox",
                    "description" => ''
                );
        if($art == 'subcat' or $art == 'page')
            $config[$art.'_indent'] = array(
                    "type" => "text",
                    "maxlength" => "3",
                    "size" => "3",
                    "description" => '',
                    "regex" => "/^\d{1,3}$/",
                    "regex_error" => $conf_txt->get('error_2')
                );

            $config[$art.'_textalign'] = array(
                    "type" => "select",
                    "description" => '',
                    "descriptions" => array('center' => $conf_txt->get('horizontal_center'),'left' => $conf_txt->get('horizontal_left'),'right' => $conf_txt->get('horizontal_right')),
                    "multiple" => "false"
                );

            $config[$art.'_horizontal'] = array(
                    "type" => "select",
                    "description" => '',
                    "descriptions" => array('center' => $conf_txt->get('horizontal_center'),'left' => $conf_txt->get('horizontal_left'),'right' => $conf_txt->get('horizontal_right')),
                    "multiple" => "false"
                );
            $config[$art.'_vertical'] = array(
                    "type" => "select",
                    "description" => '',
                    "descriptions" => array('center' => $conf_txt->get('vertical_center'),'top' => $conf_txt->get('vertical_top'),'bottom' => $conf_txt->get('vertical_bottom')),
                    "multiple" => "false"
                );
        }

        $config['--template~~'] =
                    '<div class="mo-in-li-l">{menusubs_2_description}</div>'
                    .'<div class="mo-in-li-r">{menusubs_2_select}</div>'
                .'</div>'# mozilo hat den aufgemacht
            .'</li>'
            .'<li class="mo-in-ul-li mo-inline ui-widget-content ui-corner-all ui-helper-clearfix">'
                .'<div class="mo-in-li-l">{sitemap_show_menu2_description}</div>'
                .'<div class="mo-in-li-r">{sitemap_show_menu2_checkbox}</div>'
            .'</li>'
            .'<li class="mo-in-ul-li mo-inline ui-widget-content ui-corner-all ui-helper-clearfix">'
                .'<div class="mo-in-li-l">{breadcrumb_delimiter_description}</div>'
                .'<div class="mo-in-li-r">{breadcrumb_delimiter_text}</div>'
            .'</li>';

    if(!function_exists("imagettfbbox") or !function_exists("ob_get_contents")) {
        $config['--template~~'] .=
            '<li class="mo-in-ul-li mo-inline ui-widget-content ui-corner-all ui-helper-clearfix">'
                .'<div>'# von mozilo
                .'<b style="color:#ff0000;">'
                    .$conf_txt->get('no_library')
                .'</b>';
    } elseif((count($font) <= 1 or count($img) <= 1)){
        $config['--template~~'] .=
            '<li class="mo-in-ul-li mo-inline ui-widget-content ui-corner-all ui-helper-clearfix">'
                .'<div>'# von mozilo
                .'<b>'
                    .$conf_txt->get('no_ttf_png')
                .'</b>';
    } else {
        foreach(array('cat','subcat','page') as $art) {
            $config['--template~~'] .=
            '<li class="mo-in-ul-li mo-inline ui-widget-content ui-corner-all ui-helper-clearfix">';
                if($art == 'page') $config['--template~~'] .= '<div>';# von mozilo
                $config['--template~~'] .=
                $conf_txt->get($art).' <span class="msi-toggle" style="float:right;"><label for="'.$plugin_name.'-'.$art.'_activ">'.$conf_txt->get('aktivieren').'</label> {'.$art.'_activ_checkbox}</span>'
                .'<ul class="mo-in-ul-ul">'
                    .'<li class="mo-in-ul-li mo-inline ui-widget-content ui-corner-all ui-helper-clearfix">'
                        .'<b>'.$conf_txt->get('imgfontcolor').'</b> '.$conf_txt->get('color_info')
                        .'<div style="display:table;padding-left:2em;">';
                        foreach(array('normal','activ','hover') as $status) {
                            $config['--template~~'] .=
                            '<div style="display:table-row;">'
                                .'<div style="display:table-cell;">'
                                    .$status
                                .'</div>'
                                .'<div style="display:table-cell;padding-left:2em;padding-bottom:.4em;">'
                                    .'<div style="display:inline-block;width:20em;">{'.$art.'_img_'.$status.'_select}</div>'
                                .'</div>'
                                .'<div style="display:table-cell;padding-left:2em;">'
                                    .'<div style="display:inline-block;width:20em;">{'.$art.'_font_'.$status.'_select}</div>'
                                .'</div>'
                                .'<div style="display:table-cell;padding-left:2em;">'
                                    .'{'.$art.'_fontColor_'.$status.'_text}'
                                .'</div>'
                            .'</div>';
                        }
                        $config['--template~~'] .=
                        '</div>'
                        .'<div class="msi-crop-wrap" style="display:table;padding-bottom:.4em;">'
                            .'<div style="display:table-cell;">'
                                .'<b>'.$conf_txt->get('fontsize').'</b><br />{'.$art.'_fontSize_text}'
                            .'</div>'
                            .'<div style="display:table-cell;padding-left:2em;">'
                                .'<b>'.$conf_txt->get('angel').'</b><br />{'.$art.'_angel_text}'
                            .'</div>'
                            .'<div style="display:table-cell;padding-left:2em;">'
                                .'<b>'.$conf_txt->get('linespacing').'</b><br />{'.$art.'_lineSpacing_text}'
                            .'</div>'
                            .'<div class="msi-crop-toggle" style="display:table-cell;padding-left:2em;">'
                                .'<b>'.$conf_txt->get('maxwidth').'</b><br />{'.$art.'_maxWidth_text}'
                            .'</div>'
                            .'<div class="msi-crop-toggle" style="display:table-cell;padding-left:2em;">'
                                .'<b>'.$conf_txt->get('maxheight').'</b><br />{'.$art.'_maxHeight_text}'
                            .'</div>';
                        if($art == 'subcat' or $art == 'page') {
                            $config['--template~~'] .=
                            '<div style="display:table-cell;padding-left:2em;">'
                                .'<b>'.$conf_txt->get('indent').'</b><br />{'.$art.'_indent_text}'
                            .'</div>';
                        }
                            $config['--template~~'] .=
                            '<div class="msi-crop" style="display:table-cell;padding-left:2em;">'
                                .'<b><label for="'.$plugin_name.'-'.$art.'_crop">'.$conf_txt->get('crop').'</label></b><br />{'.$art.'_crop_checkbox}'
                            .'</div>'
                        .'</div>'
                        .'<div style="display:table;">'
                            .'<div style="display:table-cell;">'
                                .'<b>'.$conf_txt->get('textalign').'</b><br />'.$conf_txt->get('horizontal').'{'.$art.'_textalign_select}'
                            .'</div>'
                            .'<div style="display:table-cell;padding-left:2em;">'
                                .'<b>'.$conf_txt->get('imagealign').'</b>'
                                .'<div style="display:table;">'
                                    .'<div style="display:table-cell;padding-right:.5em;width:50%;">'
                                        .$conf_txt->get('horizontal').'<br />{'.$art.'_horizontal_select}'
                                    .'</div>'
                                    .'<div style="display:table-cell;padding-left:.5em;width:50%;">'
                                        .$conf_txt->get('vertical').'<br />{'.$art.'_vertical_select}'
                                    .'</div>'
                                .'</div>'
                            .'</div>'
                            .'<div style="display:table-cell;padding-left:2em;">'
                                .'<b>'.$conf_txt->get('padding').'</b><br />'.$conf_txt->get('padding_info').'<br />{'.$art.'_padding_text}'
                            .'</div>'
                        .'</div>'
                    .'</li>'
                .'</ul>';
            if($art != 'page') $config['--template~~'] .= '</li>';# von mozilo
        }

        $config['--template~~'] .= '<script language="Javascript" type="text/javascript">/*<![CDATA[*/'
            .'$(function() {
                $(".msi-toggle input:not(:checked)").closest("li").find("ul").css("display","none");
                $(".msi-toggle input").on("click", function(event) {
                    if($(this).is(":checked"))
                        $(this).closest("li").find("ul").show(anim_speed);
                    else
                        $(this).closest("li").find("ul").hide(anim_speed);
                });
                $(".msi-crop input:not(:checked)").closest(".msi-crop-wrap").find(".msi-crop-toggle input").attr("disabled","disabled").css("color","#A4A4A4");
                $(".msi-crop input").on("click", function(event) {
                    if($(this).is(":checked"))
                        $(this).closest(".msi-crop-wrap").find(".msi-crop-toggle input").attr("disabled",false).css("color","");
                    else
                        $(this).closest(".msi-crop-wrap").find(".msi-crop-toggle input").attr("disabled","disabled").css("color","#A4A4A4");
                });
            });'
        .'/*]]>*/</script>';
        }
        return $config;
    }

    public function getInfo() {
        global $ADMIN_CONF;
        $plugin_name = get_class();
        if(file_exists($this->PLUGIN_SELF_DIR."lang/info_".$ADMIN_CONF->get("language").".txt"))
            $info_txt = file_get_contents($this->PLUGIN_SELF_DIR."lang/info_".$ADMIN_CONF->get("language").".txt");
        else
            $info_txt = file_get_contents($this->PLUGIN_SELF_DIR."lang/info_deDE.txt");
        $info_txt = str_replace("{PLUGINNAME}",$plugin_name,$info_txt);
        $info = array(
            // Plugin-Name
            "<b>".$plugin_name."</b> Revision: 3",
            // Plugin-Version
            "2.0",
            // Kurzbeschreibung
            $info_txt,
            // Name des Autors
            "stefanbe",
            // Download-URL
            "",
#            array("https://github.com/mozilo/mozilo2.0","moziloCMS 2.0"),
            array("{".$plugin_name."|main/detail/menusubs_2/breadcrumb}" => $plugin_name)
            );
        return $info;
    }
}

?>